// CDemoPlugIn.cpp : Defines the entry point for the DLL application.
//
#include "stdafx.h"
#include "CDemoPlugIn.h"
#include "stdlib.h"



 char ModuleFileName[MAX_PATH]; // the current module
  HWND  ParentWindowHandle;



void ShowMessage(LPCSTR s)
{
	MessageBox(ParentWindowHandle, s, "CDemoPlugIn",MB_OK);
}



BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			{


			  // Get the jugglor editor main handle

			  char s[21];
	          //SetLength(s,1024);
			  GetEnvironmentVariable("JugglorAppWindow",s,20);
              ParentWindowHandle=0;
              if (strlen(s)>0) 
			  {
                ParentWindowHandle=(HWND)atoi(s);
			  };

              GetModuleFileName((HMODULE)hModule,ModuleFileName,MAX_PATH);

		      if (ParentWindowHandle!=0)
				ShowMessage("PlugIn Loaded from the editor");
					else
				ShowMessage("PlugIn Loaded from the engine");
			}
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}


#define ThePrefix "myprefix:" // must be lowercase 

typedef int (CALLBACK *JugglorEngineCallbackType) (int OpCode, int* iParam, void* MoreParams);

JugglorEngineCallbackType JugglorEngineCallback;

// JugglorEngineCallback:function(OpCode:integer; var iParam:integer; MoreParams:pointer):integer; stdcall;
// OpCodes:
// 0 : Get the engine main window handle
// 1 : Get the Flash projector window handle (for projector based engine only)
// 2 : Get the fullscreen state, returns 1 if fullscreen.
// 3 : Return the IShockwaveFlash pointer for the ActiveX control
// 4 : Set the variable (name pointed by iParam), to have a value of a zero-ended string, pointed by MoreParams
// 5 : Get the variable (name pointed by MoreParams), to return a value (zero-ended string), pointed by iParam
//     IMPORTANT: the buffer pointed by iParam must be freed by the caller using GlobalFree
// >>> Functions 4 and 5 work with the ActiveX engine only




LPSTR ExtractFilePath(LPSTR Out, LPCSTR TheFileName)
{
	strcpy(Out,TheFileName);
	int Index=-1;
	int Len=(int)strlen(Out);
	for (int i=Len-1; i>=0; i--)
	{
		if (Out[i]=='\\') { Index=i; break; }
	};
	if ((Index>=0) && (Index<Len-1)) Out[Index+1]=0;
	return Out;
}

LPSTR ExtractFileName(LPSTR Out, LPCSTR TheFileName)
{
	int Index=0;
	int Len=(int)strlen(TheFileName);
	for (int i=Len-1; i>0; i--)
	{
		if (TheFileName[i]=='\\') { Index=i; break; }
	};
    strcpy(Out,&TheFileName[Index]);
	return Out;
}


void WINAPI JugglorInit(void* CallBackFunc, LPCSTR CommandLineParameters)
{
  char fn[MAX_PATH]; 
  char s[1125];
  char Buffer[1025];
  int Dummy;

  JugglorEngineCallback=(JugglorEngineCallbackType)CallBackFunc; // later use the callback if needed

  ParentWindowHandle=(HWND)JugglorEngineCallback(0, &Dummy, NULL); // Get the parent for dialogs

  // shows how to recontruct the file name, assuming it is only one value in Parameters
  ExtractFilePath(fn,ModuleFileName);

  strcat(fn,ExtractFileName(s,CommandLineParameters));

  strcpy(s,"PlugIn Initialialized\n");
  strcat(s,"Parameters=");
  strcat(s,CommandLineParameters);
  strcat(s,"\nFileName=");
  strcat(s,fn);

  ShowMessage(s);

  HANDLE fh;
  if ((fh=CreateFile(fn,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,0,0))!=INVALID_HANDLE_VALUE)
  {

	  memset(Buffer, 0, 1025);
	  unsigned long Bytes;
	  ReadFile(fh,&Buffer,1024,&Bytes,NULL);


	  strcpy(s,"The first 1024 characters from file content:\n");
	  strcat(s,Buffer);

      ShowMessage(s);

	  CloseHandle(fh);
  };
  

}


void WINAPI BeforeShow()
{
  ShowMessage("Actions before showing window");
};

void WINAPI AfterShow()
{
  ShowMessage("Actions after showing window");
};

char* WINAPI FSCommandFunction(char* Command, BYTE* Handled)

{

  ShowMessage("eh");
  char s[128];
  char* Result=NULL; // should be nil by default
  int Len=strlen(ThePrefix);
  strncpy(s,Command,Len);
  CharLowerBuff(s,Len);


  if (strcmp(s,ThePrefix)==0)
  
    {
	   *Handled=1; // If we want to prevent the further processing of this command
       char Message[1024];
       strcpy(Message,"The command is \"");
	   strncat(Message,&s[Len],800);
	   strcat(Message,"\", we will minimize");
       ShowMessage(Message);
       Result="minimize"; // shows how to modify the command
       *Handled=0; // tells the engine the command is not handled, so it minimizes
	}
     else *Handled=0;

  return Result;
  
}



// called from the JTools dialog in the editor
// Params is nullchar terminated list of params, each param ends with new line char
// Index is a zero based index of the currently edited param
char* WINAPI SetProperties2(char* Params, int Index)
{
  char* Result; 
  char* Parameters=Params;
  char FileName[MAX_PATH], Buffer[1025], s[1125];

  int Len=strlen(Parameters);
  if (Len>=2) Parameters[Len-2]=0; // remove the ending new line

  Result=Parameters; // This is only a demo, return the same

  if (strlen(Parameters)==0)
  {
    ShowMessage("No file name specified");
    return Result;
  };

  // Get the handle of the JTools dialog
  // Use FileName as temporary buffer
  GetEnvironmentVariable("JugglorAddCommandWindow",FileName,MAX_PATH);

  HWND h=(HWND)atoi(FileName);


  // ask the dialog for the the real path and name of the file
  //SetLength(FileName,1024);
  if (SendMessage(h,WM_USER+9,(int)Parameters,(int)FileName)!=1) 
  {
      ShowMessage("Internal error");
      return Result;
  };



  HANDLE fh;
  if ((fh=CreateFile(FileName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,0,0))!=INVALID_HANDLE_VALUE)
  {

	  memset(Buffer, 0, 1025);
	  unsigned long BytesRead;
	  ReadFile(fh,&Buffer,1024,&BytesRead,NULL);

	  strcpy(s,"The first 1024 characters from file content:\n");
	  strcat(s,Buffer);

      ShowMessage(s);

	  CloseHandle(fh);
  }
   else

   {
	 strcpy(s,"Can't find ");
	 strcat(s,FileName);
     ShowMessage(s);
   };


   return Result;
};


