library PlugInDemo;

uses
  SysUtils, Classes, Windows, Messages; 

const ThePrefix= 'myprefix:'; // must be lowercase 

var JugglorEngineCallback:function(OpCode:integer; var iParam:integer; MoreParams:pointer):integer; stdcall;
// OpCodes:
// 0 : Get the engine main window handle
// 1 : Get the Flash projector window handle (for projector based engine only)
// 2 : Get the fullscreen state, returns 1 if fullscreen.


var ModuleFileName:string; // the current module
    ParentWindowHandle:THandle;

procedure ShowMessage(s:string);
begin
  MessageBox(ParentWindowHandle,pchar(s),'DemoPlugIn',mb_ok)
end;

procedure JugglorInit(CallBackFunc:pointer; CommandLineParameters:pchar); stdcall;
var fn:string; Dummy:integer;
begin
  JugglorEngineCallback:=CallBackFunc; // later use the callback if needed

  ParentWindowHandle:=JugglorEngineCallback(0, Dummy, nil); // Get the parent for dialogs

  // shows how to recontruct the file name, assuming it is only one value in Parameters
  fn:=ExtractFilePath(ModuleFileName)+ExtractFileName(CommandLineParameters);

  ShowMessage('PlugIn Initialialized:'#13+'Parameters='+CommandLineParameters+#13'FileName='+fn);

  // Use TStringList class to load the file
//  if FileExists(fn) then
  with TStringList.Create do
  try
    LoadFromFile(fn);
    ShowMessage('The first 1024 characters from file content'#13+copy(Text,1,1024))
  finally
    Free
  end
end;

procedure BeforeShow; stdcall;
begin
  ShowMessage('Actions before showing window')
end;

procedure AfterShow; stdcall;
begin
  ShowMessage('Actions after showing window')
end;

function FSCommandFunction(Command:PChar; var Handled:boolean):PChar; stdcall;
begin
  Result:=nil; // should be nil by default
  Handled:=lowercase(copy(Command,1,length(ThePrefix)))=ThePrefix;
  if Handled then
  begin
    ShowMessage('The command is '+copy(Command,10,9999)+', we will minimize' );
    Result:='minimize'; // shows how to modify the command
    Handled:=false // tell the engine the command is not handled
  end
end;

// called from the JTools dialog in the editor
// Params is nullchar terminated list of params, each param ends with new line char
// Index is a zero based index of the currently edited param
function SetProperties2(Params:pchar; Index:integer):pchar; stdcall; export;
var Parameters,FileName:string; h:integer;
begin
  Parameters:=Params;
  if copy(Parameters,length(Parameters)-1,2)=#13#10 then // remove the ending new line
    Parameters:=copy(Parameters,1,length(Parameters)-2);
  Result:=pchar(Parameters); // This is only a demo, return the same

  if Parameters='' then
  begin
    ShowMessage('No file name specified');
    exit
  end;

  // Get the handle of the JTools dialog
  SetLength(FileName,1024); // Use FileName as temporary buffer
  SetLength(FileName,GetEnvironmentVariable('JugglorAddCommandWindow',PChar(FileName),1024));
  h:=StrToInt(FileName);


  // ask the dialog for the the real path and name of the file
  SetLength(FileName,1024);
  if SendMessage(h,WM_USER+9,integer(pchar(Parameters)),integer(PChar(FileName)))<>1 then
    begin
      ShowMessage('Internal error');
      exit;
    end;
  SetLength(FileName,StrLen(pchar(FileName)));
  if (FileName='') or not FileExists(FileName) then
    begin
      ShowMessage('Can''t find '+Parameters+':'#13+FileName);
      exit;
    end;

  // Use TFileStream class to check the size of the file  
  with TFileStream.Create(FileName,fmOpenRead+fmShareDenyNone) do
  try
    if Size>10000000 then
    begin
      ShowMessage('File too big: '+FileName);
      exit;
    end
  finally
    Free
  end;

  // Use TStringList class to load the file
  with TStringList.Create do
  try
    LoadFromFile(FileName);
    ShowMessage('The first 1024 characters from file content'#13+copy(Text,1,1024))
  finally
    Free
  end
end;

exports JugglorInit,BeforeShow,AfterShow,FSCommandFunction,SetProperties2;

var s :string;
begin

  // Get the jugglor editor main handle
  SetLength(s,1024);
  SetLength(s,GetEnvironmentVariable('JugglorAppWindow',PChar(s),1024));
  ParentWindowHandle:=0;
  if s<>'' then
  try
    ParentWindowHandle:=StrToInt(s);
  except
  end;


  SetLength(ModuleFileName,1024);
  SetLength(ModuleFileName,GetModuleFileName(hInstance,pchar(ModuleFileName),1024));
  if ParentWindowHandle<>0 then
    ShowMessage('PlugIn Loaded from the editor')
   else
    ShowMessage('PlugIn Loaded from the engine')
end.

